diff mbox series

[RFC,v2] generic: test reporting of wb errors via syncfs

Message ID 20200420162143.28170-1-jlayton@kernel.org (mailing list archive)
State New, archived
Headers show
Series [RFC,v2] generic: test reporting of wb errors via syncfs | expand

Commit Message

Jeffrey Layton April 20, 2020, 4:21 p.m. UTC
From: Jeff Layton <jlayton@redhat.com>

Add a test for new syncfs error reporting behavior. When an inode fails
to be written back, ensure that a subsequent call to syncfs() will also
report an error.

Signed-off-by: Jeff Layton <jlayton@kernel.org>
---
 tests/generic/999     | 79 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/999.out |  8 +++++
 tests/generic/group   |  1 +
 3 files changed, 88 insertions(+)
 create mode 100755 tests/generic/999
 create mode 100644 tests/generic/999.out

v2:
- update license comment
- only write a page of data
- don't bother testing for enough scratch space
- don't hold file open over test

Thanks to Brian Foster for the review! This is testing a proposed
behavior change and is dependent on this patchset being merged:

    vfs: have syncfs() return error when there are writeback errors

We'll probably want to wait until its fate is clear before merging this.

Comments

Brian Foster April 21, 2020, 2:21 p.m. UTC | #1
On Mon, Apr 20, 2020 at 12:21:43PM -0400, Jeff Layton wrote:
> From: Jeff Layton <jlayton@redhat.com>
> 
> Add a test for new syncfs error reporting behavior. When an inode fails
> to be written back, ensure that a subsequent call to syncfs() will also
> report an error.
> 
> Signed-off-by: Jeff Layton <jlayton@kernel.org>
> ---

Reviewed-by: Brian Foster <bfoster@redhat.com>

>  tests/generic/999     | 79 +++++++++++++++++++++++++++++++++++++++++++
>  tests/generic/999.out |  8 +++++
>  tests/generic/group   |  1 +
>  3 files changed, 88 insertions(+)
>  create mode 100755 tests/generic/999
>  create mode 100644 tests/generic/999.out
> 
> v2:
> - update license comment
> - only write a page of data
> - don't bother testing for enough scratch space
> - don't hold file open over test
> 
> Thanks to Brian Foster for the review! This is testing a proposed
> behavior change and is dependent on this patchset being merged:
> 
>     vfs: have syncfs() return error when there are writeback errors
> 
> We'll probably want to wait until its fate is clear before merging this.
> 
> diff --git a/tests/generic/999 b/tests/generic/999
> new file mode 100755
> index 000000000000..cdc0772d0774
> --- /dev/null
> +++ b/tests/generic/999
> @@ -0,0 +1,79 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0+
> +# Copyright (c) 2020, Jeff Layton. All rights reserved.
> +# FS QA Test No. 999
> +#
> +# Open a file and write to it and fsync. Then, flip the data device to throw
> +# errors, write to it again and do an fdatasync. Then open an O_RDONLY fd on
> +# the same file and call syncfs against it and ensure that an error is reported.
> +# Then call syncfs again and ensure that no error is reported. Finally, repeat
> +# the open and syncfs and ensure that there is no error reported.
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1    # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +	cd /
> +	rm -f $tmp.*
> +	_dmerror_cleanup
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +. ./common/dmerror
> +
> +# real QA test starts here
> +_supported_os Linux
> +_require_scratch_nocheck
> +# This test uses "dm" without taking into account the data could be on
> +# realtime subvolume, thus the test will fail with rtinherit=1
> +_require_no_rtinherit
> +_require_dm_target error
> +
> +rm -f $seqres.full
> +
> +echo "Format and mount"
> +_scratch_mkfs > $seqres.full 2>&1
> +_dmerror_init
> +_dmerror_mount
> +
> +
> +# create file
> +testfile=$SCRATCH_MNT/syncfs-reports-errors
> +touch $testfile
> +
> +# write a page of data to file, and call fsync
> +datalen=$(getconf PAGE_SIZE)
> +$XFS_IO_PROG -c "pwrite -W -q 0 $datalen" $testfile
> +
> +# flip device to non-working mode
> +_dmerror_load_error_table
> +
> +# rewrite the data and call fdatasync
> +$XFS_IO_PROG -c "pwrite -w -q 0 $datalen" $testfile
> +
> +# heal the device error
> +_dmerror_load_working_table
> +
> +# open again and call syncfs twice
> +echo "One of the following syncfs calls should fail with EIO:"
> +$XFS_IO_PROG -r -c syncfs -c syncfs $testfile
> +echo "done"
> +
> +echo "This syncfs call should succeed:"
> +$XFS_IO_PROG -r -c syncfs $testfile
> +echo "done"
> +
> +# success, all done
> +_dmerror_cleanup
> +
> +status=0
> +exit
> diff --git a/tests/generic/999.out b/tests/generic/999.out
> new file mode 100644
> index 000000000000..950a2ba42503
> --- /dev/null
> +++ b/tests/generic/999.out
> @@ -0,0 +1,8 @@
> +QA output created by 999
> +Format and mount
> +fdatasync: Input/output error
> +One of the following syncfs calls should fail with EIO:
> +syncfs: Input/output error
> +done
> +This syncfs call should succeed:
> +done
> diff --git a/tests/generic/group b/tests/generic/group
> index 718575baeef9..9bcf296fc3dd 100644
> --- a/tests/generic/group
> +++ b/tests/generic/group
> @@ -598,3 +598,4 @@
>  594 auto quick quota
>  595 auto quick encrypt
>  596 auto quick
> +999 auto quick
> -- 
> 2.25.3
>
diff mbox series

Patch

diff --git a/tests/generic/999 b/tests/generic/999
new file mode 100755
index 000000000000..cdc0772d0774
--- /dev/null
+++ b/tests/generic/999
@@ -0,0 +1,79 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0+
+# Copyright (c) 2020, Jeff Layton. All rights reserved.
+# FS QA Test No. 999
+#
+# Open a file and write to it and fsync. Then, flip the data device to throw
+# errors, write to it again and do an fdatasync. Then open an O_RDONLY fd on
+# the same file and call syncfs against it and ensure that an error is reported.
+# Then call syncfs again and ensure that no error is reported. Finally, repeat
+# the open and syncfs and ensure that there is no error reported.
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+	_dmerror_cleanup
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/dmerror
+
+# real QA test starts here
+_supported_os Linux
+_require_scratch_nocheck
+# This test uses "dm" without taking into account the data could be on
+# realtime subvolume, thus the test will fail with rtinherit=1
+_require_no_rtinherit
+_require_dm_target error
+
+rm -f $seqres.full
+
+echo "Format and mount"
+_scratch_mkfs > $seqres.full 2>&1
+_dmerror_init
+_dmerror_mount
+
+
+# create file
+testfile=$SCRATCH_MNT/syncfs-reports-errors
+touch $testfile
+
+# write a page of data to file, and call fsync
+datalen=$(getconf PAGE_SIZE)
+$XFS_IO_PROG -c "pwrite -W -q 0 $datalen" $testfile
+
+# flip device to non-working mode
+_dmerror_load_error_table
+
+# rewrite the data and call fdatasync
+$XFS_IO_PROG -c "pwrite -w -q 0 $datalen" $testfile
+
+# heal the device error
+_dmerror_load_working_table
+
+# open again and call syncfs twice
+echo "One of the following syncfs calls should fail with EIO:"
+$XFS_IO_PROG -r -c syncfs -c syncfs $testfile
+echo "done"
+
+echo "This syncfs call should succeed:"
+$XFS_IO_PROG -r -c syncfs $testfile
+echo "done"
+
+# success, all done
+_dmerror_cleanup
+
+status=0
+exit
diff --git a/tests/generic/999.out b/tests/generic/999.out
new file mode 100644
index 000000000000..950a2ba42503
--- /dev/null
+++ b/tests/generic/999.out
@@ -0,0 +1,8 @@ 
+QA output created by 999
+Format and mount
+fdatasync: Input/output error
+One of the following syncfs calls should fail with EIO:
+syncfs: Input/output error
+done
+This syncfs call should succeed:
+done
diff --git a/tests/generic/group b/tests/generic/group
index 718575baeef9..9bcf296fc3dd 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -598,3 +598,4 @@ 
 594 auto quick quota
 595 auto quick encrypt
 596 auto quick
+999 auto quick